// Popis: Plugin s novou sadou ikon
// Autor: VasaM
// Licence: CC BY 4.0 CZ


const iconsVasaM = {
	'Traditional Cache': 'traditional',
	'Multi-cache': 'multi',
	'Multi-cache solved': 'multi_solved',
	'Unknown Cache': 'unknown',
	'Unknown Cache solved': 'unknown_solved',
	'Letterbox Hybrid': 'letter',
	'Letterbox Hybrid solved': 'letter_solved',
	'Virtual Cache': 'virtual',
	'Virtual Cache solved': 'virtual_solved',
	'Webcam Cache': 'webcam',
	'Event Cache': 'event',
	'Cache In Trash Out Event': 'cito',
	'Earthcache': 'earth',
	'Wherigo Cache': 'wherigo',
	'Wherigo Cache solved': 'wherigo_solved',
	'Mega-Event Cache': 'mega',
	'Giga-Event Cache': 'giga',
	'GPS Adventures Exhibit': 'gps',
	'ape': 'ape',
	'Lab Cache': 'lab',
	'Final Location': 'final',
	'Parking Area': 'parking',
	'Question to Answer': 'question',
	'Visited question': 'question_visited',
	'Stages of a Multicache': 'stage',
	'Visited stages': 'stage_visited',
	'Trailhead': 'trailhead',
	'Reference Point': 'reference',
	'reverse': 'reverse',
	'waypoint': 'waypoint',
	'point': 'point',
}

let nactiIkonyOriginal = NactiIkony;
var cacheIcon_def, wptIcon_def;



function updateLegend() {
	legenda.innerHTML = "";
	// NactiLegendu();
	setTimeout(NactiLegendu,1000);
}



function loadDefaultIcons() {
	defaultIcon = cacheIcon_def;
	defaultWptIcon = wptIcon_def;

	nactiIkonyOriginal();
}


function loadIcons() {
	ikony   = [];
	// ikonymy = [];
	ikonyna = [];
	$.each(iconsVasaM, function(key) {
		ikony[key] = {
			icon: L.icon({
				iconUrl: './plugin/IconSet/' + this + '.png',
				iconSize: [18,30],
				iconAnchor: [9,30],
				popupAnchor: [0,-20],
				tooltipAnchor: [0,-20],
			}),
			url: './plugin/IconSet/' + this + '.png'
		};
		
		// ikonymy[key] = {
		// 	icon: L.icon({
		// 		iconUrl: './plugin/IconSet/' + this + '.my.png',
		// 		iconSize: [18,30],
		// 		iconAnchor: [9,30],
		// 		popupAnchor: [0,-20],
		// 		tooltipAnchor: [0,-20]
		// 	}),
		// 	url: './plugin/IconSet/' + this + '.my.png'
		// };

		ikonyna[key] = {
			icon: L.icon({
				iconUrl: './plugin/IconSet/' + this + '.na.png',
				iconSize: [18,30],
				iconAnchor: [9,30],
				popupAnchor: [0,-20],
				tooltipAnchor: [0,-20]
			}),
			url: './plugin/IconSet/' + this + '.na.png'
		}
	});


	defaultIcon = L.icon({
		iconUrl: './plugin/IconSet/green.png',
		iconSize:      [18, 30],
		iconAnchor:    [9,  30],
		popupAnchor:   [0, -20],
		tooltipAnchor: [0, -20],
	});
	
	defaultWptIcon = L.icon({
		iconUrl: './plugin/IconSet/waypoint.png',
		iconSize:      [18, 30],
		iconAnchor:    [9,  30],
		popupAnchor:   [0, -20],
		tooltipAnchor: [0, -20],
	});
}


function IconSet_ggm_init() {
	ggmregister('onload', function() {
		icons8Copyright();
		addCopyright('Ikony', 'Ikony od Norbert_G z <a href="https://www.geoget.cz/doku.php/user:skript:keskomapa" target="_blank">Keškomapy</a>');
		
		addFilter('Icons set', 'plugin/IconSet/icons.png', 'icon_switch', -1);
		$("#icon_switch").setTheSwitch({
			steps: 2,
			action: 'on',
			onClickOn:  function(e) {loadIcons();        load_ajax(); updateLegend();},
			onClickOff: function(e) {loadDefaultIcons(); load_ajax(); updateLegend();}
		});
	});

	
	// Prepisu puvodni funkci
	NactiIkony = function() {
		// Ulozim vychozi hodnoty
		cacheIcon_def = defaultIcon;
		wptIcon_def   = defaultWptIcon;
	
		// Nactu novou sadu
		loadIcons();

	};
	

	// Nakreslim znacky u archivovanych kesi
	paintAttrOriginal = paintAttr;
	paintAttr = function(item) {
		paintAttrOriginal(item);

		if (item.cs == 2) {
			var cm = L.circleMarker([item.x, item.y], {radius: 3, color: 'red', weight: 1, opacity: 0.7, fillOpacity: 0.4, stroke: true});
			groupAttr.addLayer(cm);
		};
	}


	ggmregister('pointname', function() {
		data = arguments[0][1];
		if (data.fi == 1) {
			switch (data.t) {
				case 'Multi-cache':       data.t = 'Multi-cache solved';       return;
				case 'Unknown Cache':     data.t = 'Unknown Cache solved';     return;
				case 'Letterbox Hybrid':  data.t = 'Letterbox Hybrid solved';  return;
				case 'Virtual Cache':     data.t = 'Virtual Cache solved';     return;
				case 'Wherigo Cache':     data.t = 'Wherigo Cache solved';     return;
			}
		}
	});
}
